<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirlinePerson ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirlinePerson
 * @subpackage Arrays
 */
class ArrayOfAirlinePerson extends AbstractStructArrayBase
{
    /**
     * The AirlinePerson
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirlinePerson[]
     */
    public $AirlinePerson;
    /**
     * Constructor method for ArrayOfAirlinePerson
     * @uses ArrayOfAirlinePerson::setAirlinePerson()
     * @param \StructType\AirlinePerson[] $airlinePerson
     */
    public function __construct(array $airlinePerson = array())
    {
        $this
            ->setAirlinePerson($airlinePerson);
    }
    /**
     * Get AirlinePerson value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirlinePerson[]|null
     */
    public function getAirlinePerson()
    {
        return isset($this->AirlinePerson) ? $this->AirlinePerson : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirlinePerson method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirlinePerson method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirlinePersonForArrayConstraintsFromSetAirlinePerson(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirlinePersonAirlinePersonItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirlinePersonAirlinePersonItem instanceof \StructType\AirlinePerson) {
                $invalidValues[] = is_object($arrayOfAirlinePersonAirlinePersonItem) ? get_class($arrayOfAirlinePersonAirlinePersonItem) : sprintf('%s(%s)', gettype($arrayOfAirlinePersonAirlinePersonItem), var_export($arrayOfAirlinePersonAirlinePersonItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirlinePerson property can only contain items of type \StructType\AirlinePerson, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirlinePerson value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirlinePerson[] $airlinePerson
     * @return \ArrayType\ArrayOfAirlinePerson
     */
    public function setAirlinePerson(array $airlinePerson = array())
    {
        // validation for constraint: array
        if ('' !== ($airlinePersonArrayErrorMessage = self::validateAirlinePersonForArrayConstraintsFromSetAirlinePerson($airlinePerson))) {
            throw new \InvalidArgumentException($airlinePersonArrayErrorMessage, __LINE__);
        }
        if (is_null($airlinePerson) || (is_array($airlinePerson) && empty($airlinePerson))) {
            unset($this->AirlinePerson);
        } else {
            $this->AirlinePerson = $airlinePerson;
        }
        return $this;
    }
    /**
     * Add item to AirlinePerson value
     * @throws \InvalidArgumentException
     * @param \StructType\AirlinePerson $item
     * @return \ArrayType\ArrayOfAirlinePerson
     */
    public function addToAirlinePerson(\StructType\AirlinePerson $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirlinePerson) {
            throw new \InvalidArgumentException(sprintf('The AirlinePerson property can only contain items of type \StructType\AirlinePerson, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirlinePerson[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirlinePerson|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirlinePerson|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirlinePerson|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirlinePerson|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirlinePerson|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirlinePerson
     */
    public function getAttributeName()
    {
        return 'AirlinePerson';
    }
}
