<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBaggage ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfBaggage
 * @subpackage Arrays
 */
class ArrayOfBaggage extends AbstractStructArrayBase
{
    /**
     * The Baggage
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Baggage[]
     */
    public $Baggage;
    /**
     * Constructor method for ArrayOfBaggage
     * @uses ArrayOfBaggage::setBaggage()
     * @param \StructType\Baggage[] $baggage
     */
    public function __construct(array $baggage = array())
    {
        $this
            ->setBaggage($baggage);
    }
    /**
     * Get Baggage value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Baggage[]|null
     */
    public function getBaggage()
    {
        return isset($this->Baggage) ? $this->Baggage : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBaggage method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBaggage method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBaggageForArrayConstraintsFromSetBaggage(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBaggageBaggageItem) {
            // validation for constraint: itemType
            if (!$arrayOfBaggageBaggageItem instanceof \StructType\Baggage) {
                $invalidValues[] = is_object($arrayOfBaggageBaggageItem) ? get_class($arrayOfBaggageBaggageItem) : sprintf('%s(%s)', gettype($arrayOfBaggageBaggageItem), var_export($arrayOfBaggageBaggageItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Baggage property can only contain items of type \StructType\Baggage, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Baggage value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Baggage[] $baggage
     * @return \ArrayType\ArrayOfBaggage
     */
    public function setBaggage(array $baggage = array())
    {
        // validation for constraint: array
        if ('' !== ($baggageArrayErrorMessage = self::validateBaggageForArrayConstraintsFromSetBaggage($baggage))) {
            throw new \InvalidArgumentException($baggageArrayErrorMessage, __LINE__);
        }
        if (is_null($baggage) || (is_array($baggage) && empty($baggage))) {
            unset($this->Baggage);
        } else {
            $this->Baggage = $baggage;
        }
        return $this;
    }
    /**
     * Add item to Baggage value
     * @throws \InvalidArgumentException
     * @param \StructType\Baggage $item
     * @return \ArrayType\ArrayOfBaggage
     */
    public function addToBaggage(\StructType\Baggage $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Baggage) {
            throw new \InvalidArgumentException(sprintf('The Baggage property can only contain items of type \StructType\Baggage, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Baggage[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Baggage|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Baggage|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Baggage|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Baggage|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Baggage|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Baggage
     */
    public function getAttributeName()
    {
        return 'Baggage';
    }
}
