<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfChargeOverrideDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfChargeOverrideDetail
 * @subpackage Arrays
 */
class ArrayOfChargeOverrideDetail extends AbstractStructArrayBase
{
    /**
     * The ChargeOverrideDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ChargeOverrideDetail[]
     */
    public $ChargeOverrideDetail;
    /**
     * Constructor method for ArrayOfChargeOverrideDetail
     * @uses ArrayOfChargeOverrideDetail::setChargeOverrideDetail()
     * @param \StructType\ChargeOverrideDetail[] $chargeOverrideDetail
     */
    public function __construct(array $chargeOverrideDetail = array())
    {
        $this
            ->setChargeOverrideDetail($chargeOverrideDetail);
    }
    /**
     * Get ChargeOverrideDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ChargeOverrideDetail[]|null
     */
    public function getChargeOverrideDetail()
    {
        return isset($this->ChargeOverrideDetail) ? $this->ChargeOverrideDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setChargeOverrideDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setChargeOverrideDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateChargeOverrideDetailForArrayConstraintsFromSetChargeOverrideDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfChargeOverrideDetailChargeOverrideDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfChargeOverrideDetailChargeOverrideDetailItem instanceof \StructType\ChargeOverrideDetail) {
                $invalidValues[] = is_object($arrayOfChargeOverrideDetailChargeOverrideDetailItem) ? get_class($arrayOfChargeOverrideDetailChargeOverrideDetailItem) : sprintf('%s(%s)', gettype($arrayOfChargeOverrideDetailChargeOverrideDetailItem), var_export($arrayOfChargeOverrideDetailChargeOverrideDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ChargeOverrideDetail property can only contain items of type \StructType\ChargeOverrideDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ChargeOverrideDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ChargeOverrideDetail[] $chargeOverrideDetail
     * @return \ArrayType\ArrayOfChargeOverrideDetail
     */
    public function setChargeOverrideDetail(array $chargeOverrideDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($chargeOverrideDetailArrayErrorMessage = self::validateChargeOverrideDetailForArrayConstraintsFromSetChargeOverrideDetail($chargeOverrideDetail))) {
            throw new \InvalidArgumentException($chargeOverrideDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($chargeOverrideDetail) || (is_array($chargeOverrideDetail) && empty($chargeOverrideDetail))) {
            unset($this->ChargeOverrideDetail);
        } else {
            $this->ChargeOverrideDetail = $chargeOverrideDetail;
        }
        return $this;
    }
    /**
     * Add item to ChargeOverrideDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\ChargeOverrideDetail $item
     * @return \ArrayType\ArrayOfChargeOverrideDetail
     */
    public function addToChargeOverrideDetail(\StructType\ChargeOverrideDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ChargeOverrideDetail) {
            throw new \InvalidArgumentException(sprintf('The ChargeOverrideDetail property can only contain items of type \StructType\ChargeOverrideDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ChargeOverrideDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ChargeOverrideDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ChargeOverrideDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ChargeOverrideDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ChargeOverrideDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ChargeOverrideDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ChargeOverrideDetail
     */
    public function getAttributeName()
    {
        return 'ChargeOverrideDetail';
    }
}
