<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFareBasisList ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFareBasisList
 * @subpackage Arrays
 */
class ArrayOfFareBasisList extends AbstractStructArrayBase
{
    /**
     * The FareBasisList
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FareBasisList[]
     */
    public $FareBasisList;
    /**
     * Constructor method for ArrayOfFareBasisList
     * @uses ArrayOfFareBasisList::setFareBasisList()
     * @param \StructType\FareBasisList[] $fareBasisList
     */
    public function __construct(array $fareBasisList = array())
    {
        $this
            ->setFareBasisList($fareBasisList);
    }
    /**
     * Get FareBasisList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FareBasisList[]|null
     */
    public function getFareBasisList()
    {
        return isset($this->FareBasisList) ? $this->FareBasisList : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFareBasisList method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFareBasisList method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFareBasisListForArrayConstraintsFromSetFareBasisList(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFareBasisListFareBasisListItem) {
            // validation for constraint: itemType
            if (!$arrayOfFareBasisListFareBasisListItem instanceof \StructType\FareBasisList) {
                $invalidValues[] = is_object($arrayOfFareBasisListFareBasisListItem) ? get_class($arrayOfFareBasisListFareBasisListItem) : sprintf('%s(%s)', gettype($arrayOfFareBasisListFareBasisListItem), var_export($arrayOfFareBasisListFareBasisListItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FareBasisList property can only contain items of type \StructType\FareBasisList, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FareBasisList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FareBasisList[] $fareBasisList
     * @return \ArrayType\ArrayOfFareBasisList
     */
    public function setFareBasisList(array $fareBasisList = array())
    {
        // validation for constraint: array
        if ('' !== ($fareBasisListArrayErrorMessage = self::validateFareBasisListForArrayConstraintsFromSetFareBasisList($fareBasisList))) {
            throw new \InvalidArgumentException($fareBasisListArrayErrorMessage, __LINE__);
        }
        if (is_null($fareBasisList) || (is_array($fareBasisList) && empty($fareBasisList))) {
            unset($this->FareBasisList);
        } else {
            $this->FareBasisList = $fareBasisList;
        }
        return $this;
    }
    /**
     * Add item to FareBasisList value
     * @throws \InvalidArgumentException
     * @param \StructType\FareBasisList $item
     * @return \ArrayType\ArrayOfFareBasisList
     */
    public function addToFareBasisList(\StructType\FareBasisList $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FareBasisList) {
            throw new \InvalidArgumentException(sprintf('The FareBasisList property can only contain items of type \StructType\FareBasisList, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FareBasisList[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FareBasisList|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FareBasisList|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FareBasisList|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FareBasisList|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FareBasisList|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FareBasisList
     */
    public function getAttributeName()
    {
        return 'FareBasisList';
    }
}
