<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGDSHistory ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGDSHistory
 * @subpackage Arrays
 */
class ArrayOfGDSHistory extends AbstractStructArrayBase
{
    /**
     * The GDSHistory
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GDSHistory[]
     */
    public $GDSHistory;
    /**
     * Constructor method for ArrayOfGDSHistory
     * @uses ArrayOfGDSHistory::setGDSHistory()
     * @param \StructType\GDSHistory[] $gDSHistory
     */
    public function __construct(array $gDSHistory = array())
    {
        $this
            ->setGDSHistory($gDSHistory);
    }
    /**
     * Get GDSHistory value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GDSHistory[]|null
     */
    public function getGDSHistory()
    {
        return isset($this->GDSHistory) ? $this->GDSHistory : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGDSHistory method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGDSHistory method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGDSHistoryForArrayConstraintsFromSetGDSHistory(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGDSHistoryGDSHistoryItem) {
            // validation for constraint: itemType
            if (!$arrayOfGDSHistoryGDSHistoryItem instanceof \StructType\GDSHistory) {
                $invalidValues[] = is_object($arrayOfGDSHistoryGDSHistoryItem) ? get_class($arrayOfGDSHistoryGDSHistoryItem) : sprintf('%s(%s)', gettype($arrayOfGDSHistoryGDSHistoryItem), var_export($arrayOfGDSHistoryGDSHistoryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GDSHistory property can only contain items of type \StructType\GDSHistory, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GDSHistory value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GDSHistory[] $gDSHistory
     * @return \ArrayType\ArrayOfGDSHistory
     */
    public function setGDSHistory(array $gDSHistory = array())
    {
        // validation for constraint: array
        if ('' !== ($gDSHistoryArrayErrorMessage = self::validateGDSHistoryForArrayConstraintsFromSetGDSHistory($gDSHistory))) {
            throw new \InvalidArgumentException($gDSHistoryArrayErrorMessage, __LINE__);
        }
        if (is_null($gDSHistory) || (is_array($gDSHistory) && empty($gDSHistory))) {
            unset($this->GDSHistory);
        } else {
            $this->GDSHistory = $gDSHistory;
        }
        return $this;
    }
    /**
     * Add item to GDSHistory value
     * @throws \InvalidArgumentException
     * @param \StructType\GDSHistory $item
     * @return \ArrayType\ArrayOfGDSHistory
     */
    public function addToGDSHistory(\StructType\GDSHistory $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GDSHistory) {
            throw new \InvalidArgumentException(sprintf('The GDSHistory property can only contain items of type \StructType\GDSHistory, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GDSHistory[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GDSHistory|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GDSHistory|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GDSHistory|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GDSHistory|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GDSHistory|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GDSHistory
     */
    public function getAttributeName()
    {
        return 'GDSHistory';
    }
}
