<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHoldRule ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfHoldRule
 * @subpackage Arrays
 */
class ArrayOfHoldRule extends AbstractStructArrayBase
{
    /**
     * The HoldRule
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\HoldRule[]
     */
    public $HoldRule;
    /**
     * Constructor method for ArrayOfHoldRule
     * @uses ArrayOfHoldRule::setHoldRule()
     * @param \StructType\HoldRule[] $holdRule
     */
    public function __construct(array $holdRule = array())
    {
        $this
            ->setHoldRule($holdRule);
    }
    /**
     * Get HoldRule value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\HoldRule[]|null
     */
    public function getHoldRule()
    {
        return isset($this->HoldRule) ? $this->HoldRule : null;
    }
    /**
     * This method is responsible for validating the values passed to the setHoldRule method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHoldRule method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHoldRuleForArrayConstraintsFromSetHoldRule(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfHoldRuleHoldRuleItem) {
            // validation for constraint: itemType
            if (!$arrayOfHoldRuleHoldRuleItem instanceof \StructType\HoldRule) {
                $invalidValues[] = is_object($arrayOfHoldRuleHoldRuleItem) ? get_class($arrayOfHoldRuleHoldRuleItem) : sprintf('%s(%s)', gettype($arrayOfHoldRuleHoldRuleItem), var_export($arrayOfHoldRuleHoldRuleItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The HoldRule property can only contain items of type \StructType\HoldRule, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set HoldRule value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\HoldRule[] $holdRule
     * @return \ArrayType\ArrayOfHoldRule
     */
    public function setHoldRule(array $holdRule = array())
    {
        // validation for constraint: array
        if ('' !== ($holdRuleArrayErrorMessage = self::validateHoldRuleForArrayConstraintsFromSetHoldRule($holdRule))) {
            throw new \InvalidArgumentException($holdRuleArrayErrorMessage, __LINE__);
        }
        if (is_null($holdRule) || (is_array($holdRule) && empty($holdRule))) {
            unset($this->HoldRule);
        } else {
            $this->HoldRule = $holdRule;
        }
        return $this;
    }
    /**
     * Add item to HoldRule value
     * @throws \InvalidArgumentException
     * @param \StructType\HoldRule $item
     * @return \ArrayType\ArrayOfHoldRule
     */
    public function addToHoldRule(\StructType\HoldRule $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\HoldRule) {
            throw new \InvalidArgumentException(sprintf('The HoldRule property can only contain items of type \StructType\HoldRule, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->HoldRule[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\HoldRule|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\HoldRule|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\HoldRule|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\HoldRule|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\HoldRule|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HoldRule
     */
    public function getAttributeName()
    {
        return 'HoldRule';
    }
}
