<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLogicalFlight ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLogicalFlight
 * @subpackage Arrays
 */
class ArrayOfLogicalFlight extends AbstractStructArrayBase
{
    /**
     * The LogicalFlight
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\LogicalFlight[]
     */
    public $LogicalFlight;
    /**
     * Constructor method for ArrayOfLogicalFlight
     * @uses ArrayOfLogicalFlight::setLogicalFlight()
     * @param \StructType\LogicalFlight[] $logicalFlight
     */
    public function __construct(array $logicalFlight = array())
    {
        $this
            ->setLogicalFlight($logicalFlight);
    }
    /**
     * Get LogicalFlight value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\LogicalFlight[]|null
     */
    public function getLogicalFlight()
    {
        return isset($this->LogicalFlight) ? $this->LogicalFlight : null;
    }
    /**
     * This method is responsible for validating the values passed to the setLogicalFlight method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLogicalFlight method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLogicalFlightForArrayConstraintsFromSetLogicalFlight(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfLogicalFlightLogicalFlightItem) {
            // validation for constraint: itemType
            if (!$arrayOfLogicalFlightLogicalFlightItem instanceof \StructType\LogicalFlight) {
                $invalidValues[] = is_object($arrayOfLogicalFlightLogicalFlightItem) ? get_class($arrayOfLogicalFlightLogicalFlightItem) : sprintf('%s(%s)', gettype($arrayOfLogicalFlightLogicalFlightItem), var_export($arrayOfLogicalFlightLogicalFlightItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LogicalFlight property can only contain items of type \StructType\LogicalFlight, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set LogicalFlight value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\LogicalFlight[] $logicalFlight
     * @return \ArrayType\ArrayOfLogicalFlight
     */
    public function setLogicalFlight(array $logicalFlight = array())
    {
        // validation for constraint: array
        if ('' !== ($logicalFlightArrayErrorMessage = self::validateLogicalFlightForArrayConstraintsFromSetLogicalFlight($logicalFlight))) {
            throw new \InvalidArgumentException($logicalFlightArrayErrorMessage, __LINE__);
        }
        if (is_null($logicalFlight) || (is_array($logicalFlight) && empty($logicalFlight))) {
            unset($this->LogicalFlight);
        } else {
            $this->LogicalFlight = $logicalFlight;
        }
        return $this;
    }
    /**
     * Add item to LogicalFlight value
     * @throws \InvalidArgumentException
     * @param \StructType\LogicalFlight $item
     * @return \ArrayType\ArrayOfLogicalFlight
     */
    public function addToLogicalFlight(\StructType\LogicalFlight $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LogicalFlight) {
            throw new \InvalidArgumentException(sprintf('The LogicalFlight property can only contain items of type \StructType\LogicalFlight, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LogicalFlight[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\LogicalFlight|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\LogicalFlight|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\LogicalFlight|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\LogicalFlight|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\LogicalFlight|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LogicalFlight
     */
    public function getAttributeName()
    {
        return 'LogicalFlight';
    }
}
