<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOAFlight ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOAFlight
 * @subpackage Arrays
 */
class ArrayOfOAFlight extends AbstractStructArrayBase
{
    /**
     * The OAFlight
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OAFlight[]
     */
    public $OAFlight;
    /**
     * Constructor method for ArrayOfOAFlight
     * @uses ArrayOfOAFlight::setOAFlight()
     * @param \StructType\OAFlight[] $oAFlight
     */
    public function __construct(array $oAFlight = array())
    {
        $this
            ->setOAFlight($oAFlight);
    }
    /**
     * Get OAFlight value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OAFlight[]|null
     */
    public function getOAFlight()
    {
        return isset($this->OAFlight) ? $this->OAFlight : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOAFlight method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOAFlight method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOAFlightForArrayConstraintsFromSetOAFlight(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOAFlightOAFlightItem) {
            // validation for constraint: itemType
            if (!$arrayOfOAFlightOAFlightItem instanceof \StructType\OAFlight) {
                $invalidValues[] = is_object($arrayOfOAFlightOAFlightItem) ? get_class($arrayOfOAFlightOAFlightItem) : sprintf('%s(%s)', gettype($arrayOfOAFlightOAFlightItem), var_export($arrayOfOAFlightOAFlightItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OAFlight property can only contain items of type \StructType\OAFlight, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OAFlight value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OAFlight[] $oAFlight
     * @return \ArrayType\ArrayOfOAFlight
     */
    public function setOAFlight(array $oAFlight = array())
    {
        // validation for constraint: array
        if ('' !== ($oAFlightArrayErrorMessage = self::validateOAFlightForArrayConstraintsFromSetOAFlight($oAFlight))) {
            throw new \InvalidArgumentException($oAFlightArrayErrorMessage, __LINE__);
        }
        if (is_null($oAFlight) || (is_array($oAFlight) && empty($oAFlight))) {
            unset($this->OAFlight);
        } else {
            $this->OAFlight = $oAFlight;
        }
        return $this;
    }
    /**
     * Add item to OAFlight value
     * @throws \InvalidArgumentException
     * @param \StructType\OAFlight $item
     * @return \ArrayType\ArrayOfOAFlight
     */
    public function addToOAFlight(\StructType\OAFlight $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OAFlight) {
            throw new \InvalidArgumentException(sprintf('The OAFlight property can only contain items of type \StructType\OAFlight, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OAFlight[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OAFlight|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OAFlight|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OAFlight|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OAFlight|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OAFlight|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OAFlight
     */
    public function getAttributeName()
    {
        return 'OAFlight';
    }
}
