<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOAFlightPerson ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOAFlightPerson
 * @subpackage Arrays
 */
class ArrayOfOAFlightPerson extends AbstractStructArrayBase
{
    /**
     * The OAFlightPerson
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OAFlightPerson[]
     */
    public $OAFlightPerson;
    /**
     * Constructor method for ArrayOfOAFlightPerson
     * @uses ArrayOfOAFlightPerson::setOAFlightPerson()
     * @param \StructType\OAFlightPerson[] $oAFlightPerson
     */
    public function __construct(array $oAFlightPerson = array())
    {
        $this
            ->setOAFlightPerson($oAFlightPerson);
    }
    /**
     * Get OAFlightPerson value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OAFlightPerson[]|null
     */
    public function getOAFlightPerson()
    {
        return isset($this->OAFlightPerson) ? $this->OAFlightPerson : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOAFlightPerson method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOAFlightPerson method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOAFlightPersonForArrayConstraintsFromSetOAFlightPerson(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOAFlightPersonOAFlightPersonItem) {
            // validation for constraint: itemType
            if (!$arrayOfOAFlightPersonOAFlightPersonItem instanceof \StructType\OAFlightPerson) {
                $invalidValues[] = is_object($arrayOfOAFlightPersonOAFlightPersonItem) ? get_class($arrayOfOAFlightPersonOAFlightPersonItem) : sprintf('%s(%s)', gettype($arrayOfOAFlightPersonOAFlightPersonItem), var_export($arrayOfOAFlightPersonOAFlightPersonItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OAFlightPerson property can only contain items of type \StructType\OAFlightPerson, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OAFlightPerson value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OAFlightPerson[] $oAFlightPerson
     * @return \ArrayType\ArrayOfOAFlightPerson
     */
    public function setOAFlightPerson(array $oAFlightPerson = array())
    {
        // validation for constraint: array
        if ('' !== ($oAFlightPersonArrayErrorMessage = self::validateOAFlightPersonForArrayConstraintsFromSetOAFlightPerson($oAFlightPerson))) {
            throw new \InvalidArgumentException($oAFlightPersonArrayErrorMessage, __LINE__);
        }
        if (is_null($oAFlightPerson) || (is_array($oAFlightPerson) && empty($oAFlightPerson))) {
            unset($this->OAFlightPerson);
        } else {
            $this->OAFlightPerson = $oAFlightPerson;
        }
        return $this;
    }
    /**
     * Add item to OAFlightPerson value
     * @throws \InvalidArgumentException
     * @param \StructType\OAFlightPerson $item
     * @return \ArrayType\ArrayOfOAFlightPerson
     */
    public function addToOAFlightPerson(\StructType\OAFlightPerson $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OAFlightPerson) {
            throw new \InvalidArgumentException(sprintf('The OAFlightPerson property can only contain items of type \StructType\OAFlightPerson, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OAFlightPerson[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OAFlightPerson|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OAFlightPerson|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OAFlightPerson|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OAFlightPerson|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OAFlightPerson|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OAFlightPerson
     */
    public function getAttributeName()
    {
        return 'OAFlightPerson';
    }
}
