<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPaymentMetaData ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPaymentMetaData
 * @subpackage Arrays
 */
class ArrayOfPaymentMetaData extends AbstractStructArrayBase
{
    /**
     * The PaymentMetaData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PaymentMetaData[]
     */
    public $PaymentMetaData;
    /**
     * Constructor method for ArrayOfPaymentMetaData
     * @uses ArrayOfPaymentMetaData::setPaymentMetaData()
     * @param \StructType\PaymentMetaData[] $paymentMetaData
     */
    public function __construct(array $paymentMetaData = array())
    {
        $this
            ->setPaymentMetaData($paymentMetaData);
    }
    /**
     * Get PaymentMetaData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PaymentMetaData[]|null
     */
    public function getPaymentMetaData()
    {
        return isset($this->PaymentMetaData) ? $this->PaymentMetaData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPaymentMetaData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPaymentMetaData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePaymentMetaDataForArrayConstraintsFromSetPaymentMetaData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPaymentMetaDataPaymentMetaDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPaymentMetaDataPaymentMetaDataItem instanceof \StructType\PaymentMetaData) {
                $invalidValues[] = is_object($arrayOfPaymentMetaDataPaymentMetaDataItem) ? get_class($arrayOfPaymentMetaDataPaymentMetaDataItem) : sprintf('%s(%s)', gettype($arrayOfPaymentMetaDataPaymentMetaDataItem), var_export($arrayOfPaymentMetaDataPaymentMetaDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PaymentMetaData property can only contain items of type \StructType\PaymentMetaData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PaymentMetaData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PaymentMetaData[] $paymentMetaData
     * @return \ArrayType\ArrayOfPaymentMetaData
     */
    public function setPaymentMetaData(array $paymentMetaData = array())
    {
        // validation for constraint: array
        if ('' !== ($paymentMetaDataArrayErrorMessage = self::validatePaymentMetaDataForArrayConstraintsFromSetPaymentMetaData($paymentMetaData))) {
            throw new \InvalidArgumentException($paymentMetaDataArrayErrorMessage, __LINE__);
        }
        if (is_null($paymentMetaData) || (is_array($paymentMetaData) && empty($paymentMetaData))) {
            unset($this->PaymentMetaData);
        } else {
            $this->PaymentMetaData = $paymentMetaData;
        }
        return $this;
    }
    /**
     * Add item to PaymentMetaData value
     * @throws \InvalidArgumentException
     * @param \StructType\PaymentMetaData $item
     * @return \ArrayType\ArrayOfPaymentMetaData
     */
    public function addToPaymentMetaData(\StructType\PaymentMetaData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PaymentMetaData) {
            throw new \InvalidArgumentException(sprintf('The PaymentMetaData property can only contain items of type \StructType\PaymentMetaData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PaymentMetaData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PaymentMetaData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PaymentMetaData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PaymentMetaData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PaymentMetaData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PaymentMetaData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PaymentMetaData
     */
    public function getAttributeName()
    {
        return 'PaymentMetaData';
    }
}
