<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPhysicalFlight ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPhysicalFlight
 * @subpackage Arrays
 */
class ArrayOfPhysicalFlight extends AbstractStructArrayBase
{
    /**
     * The PhysicalFlight
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PhysicalFlight[]
     */
    public $PhysicalFlight;
    /**
     * Constructor method for ArrayOfPhysicalFlight
     * @uses ArrayOfPhysicalFlight::setPhysicalFlight()
     * @param \StructType\PhysicalFlight[] $physicalFlight
     */
    public function __construct(array $physicalFlight = array())
    {
        $this
            ->setPhysicalFlight($physicalFlight);
    }
    /**
     * Get PhysicalFlight value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PhysicalFlight[]|null
     */
    public function getPhysicalFlight()
    {
        return isset($this->PhysicalFlight) ? $this->PhysicalFlight : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPhysicalFlight method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPhysicalFlight method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePhysicalFlightForArrayConstraintsFromSetPhysicalFlight(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPhysicalFlightPhysicalFlightItem) {
            // validation for constraint: itemType
            if (!$arrayOfPhysicalFlightPhysicalFlightItem instanceof \StructType\PhysicalFlight) {
                $invalidValues[] = is_object($arrayOfPhysicalFlightPhysicalFlightItem) ? get_class($arrayOfPhysicalFlightPhysicalFlightItem) : sprintf('%s(%s)', gettype($arrayOfPhysicalFlightPhysicalFlightItem), var_export($arrayOfPhysicalFlightPhysicalFlightItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PhysicalFlight property can only contain items of type \StructType\PhysicalFlight, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PhysicalFlight value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PhysicalFlight[] $physicalFlight
     * @return \ArrayType\ArrayOfPhysicalFlight
     */
    public function setPhysicalFlight(array $physicalFlight = array())
    {
        // validation for constraint: array
        if ('' !== ($physicalFlightArrayErrorMessage = self::validatePhysicalFlightForArrayConstraintsFromSetPhysicalFlight($physicalFlight))) {
            throw new \InvalidArgumentException($physicalFlightArrayErrorMessage, __LINE__);
        }
        if (is_null($physicalFlight) || (is_array($physicalFlight) && empty($physicalFlight))) {
            unset($this->PhysicalFlight);
        } else {
            $this->PhysicalFlight = $physicalFlight;
        }
        return $this;
    }
    /**
     * Add item to PhysicalFlight value
     * @throws \InvalidArgumentException
     * @param \StructType\PhysicalFlight $item
     * @return \ArrayType\ArrayOfPhysicalFlight
     */
    public function addToPhysicalFlight(\StructType\PhysicalFlight $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PhysicalFlight) {
            throw new \InvalidArgumentException(sprintf('The PhysicalFlight property can only contain items of type \StructType\PhysicalFlight, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PhysicalFlight[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PhysicalFlight|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PhysicalFlight|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PhysicalFlight|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PhysicalFlight|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PhysicalFlight|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PhysicalFlight
     */
    public function getAttributeName()
    {
        return 'PhysicalFlight';
    }
}
