<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfReservationContact ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfReservationContact
 * @subpackage Arrays
 */
class ArrayOfReservationContact extends AbstractStructArrayBase
{
    /**
     * The ReservationContact
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ReservationContact[]
     */
    public $ReservationContact;
    /**
     * Constructor method for ArrayOfReservationContact
     * @uses ArrayOfReservationContact::setReservationContact()
     * @param \StructType\ReservationContact[] $reservationContact
     */
    public function __construct(array $reservationContact = array())
    {
        $this
            ->setReservationContact($reservationContact);
    }
    /**
     * Get ReservationContact value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ReservationContact[]|null
     */
    public function getReservationContact()
    {
        return isset($this->ReservationContact) ? $this->ReservationContact : null;
    }
    /**
     * This method is responsible for validating the values passed to the setReservationContact method
     * This method is willingly generated in order to preserve the one-line inline validation within the setReservationContact method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateReservationContactForArrayConstraintsFromSetReservationContact(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfReservationContactReservationContactItem) {
            // validation for constraint: itemType
            if (!$arrayOfReservationContactReservationContactItem instanceof \StructType\ReservationContact) {
                $invalidValues[] = is_object($arrayOfReservationContactReservationContactItem) ? get_class($arrayOfReservationContactReservationContactItem) : sprintf('%s(%s)', gettype($arrayOfReservationContactReservationContactItem), var_export($arrayOfReservationContactReservationContactItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ReservationContact property can only contain items of type \StructType\ReservationContact, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ReservationContact value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ReservationContact[] $reservationContact
     * @return \ArrayType\ArrayOfReservationContact
     */
    public function setReservationContact(array $reservationContact = array())
    {
        // validation for constraint: array
        if ('' !== ($reservationContactArrayErrorMessage = self::validateReservationContactForArrayConstraintsFromSetReservationContact($reservationContact))) {
            throw new \InvalidArgumentException($reservationContactArrayErrorMessage, __LINE__);
        }
        if (is_null($reservationContact) || (is_array($reservationContact) && empty($reservationContact))) {
            unset($this->ReservationContact);
        } else {
            $this->ReservationContact = $reservationContact;
        }
        return $this;
    }
    /**
     * Add item to ReservationContact value
     * @throws \InvalidArgumentException
     * @param \StructType\ReservationContact $item
     * @return \ArrayType\ArrayOfReservationContact
     */
    public function addToReservationContact(\StructType\ReservationContact $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ReservationContact) {
            throw new \InvalidArgumentException(sprintf('The ReservationContact property can only contain items of type \StructType\ReservationContact, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ReservationContact[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ReservationContact|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ReservationContact|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ReservationContact|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ReservationContact|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ReservationContact|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ReservationContact
     */
    public function getAttributeName()
    {
        return 'ReservationContact';
    }
}
