<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSeatAssignment ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSeatAssignment
 * @subpackage Arrays
 */
class ArrayOfSeatAssignment extends AbstractStructArrayBase
{
    /**
     * The SeatAssignment
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SeatAssignment[]
     */
    public $SeatAssignment;
    /**
     * Constructor method for ArrayOfSeatAssignment
     * @uses ArrayOfSeatAssignment::setSeatAssignment()
     * @param \StructType\SeatAssignment[] $seatAssignment
     */
    public function __construct(array $seatAssignment = array())
    {
        $this
            ->setSeatAssignment($seatAssignment);
    }
    /**
     * Get SeatAssignment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SeatAssignment[]|null
     */
    public function getSeatAssignment()
    {
        return isset($this->SeatAssignment) ? $this->SeatAssignment : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSeatAssignment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSeatAssignment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSeatAssignmentForArrayConstraintsFromSetSeatAssignment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSeatAssignmentSeatAssignmentItem) {
            // validation for constraint: itemType
            if (!$arrayOfSeatAssignmentSeatAssignmentItem instanceof \StructType\SeatAssignment) {
                $invalidValues[] = is_object($arrayOfSeatAssignmentSeatAssignmentItem) ? get_class($arrayOfSeatAssignmentSeatAssignmentItem) : sprintf('%s(%s)', gettype($arrayOfSeatAssignmentSeatAssignmentItem), var_export($arrayOfSeatAssignmentSeatAssignmentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SeatAssignment property can only contain items of type \StructType\SeatAssignment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SeatAssignment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SeatAssignment[] $seatAssignment
     * @return \ArrayType\ArrayOfSeatAssignment
     */
    public function setSeatAssignment(array $seatAssignment = array())
    {
        // validation for constraint: array
        if ('' !== ($seatAssignmentArrayErrorMessage = self::validateSeatAssignmentForArrayConstraintsFromSetSeatAssignment($seatAssignment))) {
            throw new \InvalidArgumentException($seatAssignmentArrayErrorMessage, __LINE__);
        }
        if (is_null($seatAssignment) || (is_array($seatAssignment) && empty($seatAssignment))) {
            unset($this->SeatAssignment);
        } else {
            $this->SeatAssignment = $seatAssignment;
        }
        return $this;
    }
    /**
     * Add item to SeatAssignment value
     * @throws \InvalidArgumentException
     * @param \StructType\SeatAssignment $item
     * @return \ArrayType\ArrayOfSeatAssignment
     */
    public function addToSeatAssignment(\StructType\SeatAssignment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SeatAssignment) {
            throw new \InvalidArgumentException(sprintf('The SeatAssignment property can only contain items of type \StructType\SeatAssignment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SeatAssignment[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SeatAssignment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SeatAssignment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SeatAssignment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SeatAssignment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SeatAssignment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeatAssignment
     */
    public function getAttributeName()
    {
        return 'SeatAssignment';
    }
}
