<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSeatAttribute ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSeatAttribute
 * @subpackage Arrays
 */
class ArrayOfSeatAttribute extends AbstractStructArrayBase
{
    /**
     * The SeatAttribute
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SeatAttribute[]
     */
    public $SeatAttribute;
    /**
     * Constructor method for ArrayOfSeatAttribute
     * @uses ArrayOfSeatAttribute::setSeatAttribute()
     * @param \StructType\SeatAttribute[] $seatAttribute
     */
    public function __construct(array $seatAttribute = array())
    {
        $this
            ->setSeatAttribute($seatAttribute);
    }
    /**
     * Get SeatAttribute value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SeatAttribute[]|null
     */
    public function getSeatAttribute()
    {
        return isset($this->SeatAttribute) ? $this->SeatAttribute : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSeatAttribute method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSeatAttribute method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSeatAttributeForArrayConstraintsFromSetSeatAttribute(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSeatAttributeSeatAttributeItem) {
            // validation for constraint: itemType
            if (!$arrayOfSeatAttributeSeatAttributeItem instanceof \StructType\SeatAttribute) {
                $invalidValues[] = is_object($arrayOfSeatAttributeSeatAttributeItem) ? get_class($arrayOfSeatAttributeSeatAttributeItem) : sprintf('%s(%s)', gettype($arrayOfSeatAttributeSeatAttributeItem), var_export($arrayOfSeatAttributeSeatAttributeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SeatAttribute property can only contain items of type \StructType\SeatAttribute, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SeatAttribute value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SeatAttribute[] $seatAttribute
     * @return \ArrayType\ArrayOfSeatAttribute
     */
    public function setSeatAttribute(array $seatAttribute = array())
    {
        // validation for constraint: array
        if ('' !== ($seatAttributeArrayErrorMessage = self::validateSeatAttributeForArrayConstraintsFromSetSeatAttribute($seatAttribute))) {
            throw new \InvalidArgumentException($seatAttributeArrayErrorMessage, __LINE__);
        }
        if (is_null($seatAttribute) || (is_array($seatAttribute) && empty($seatAttribute))) {
            unset($this->SeatAttribute);
        } else {
            $this->SeatAttribute = $seatAttribute;
        }
        return $this;
    }
    /**
     * Add item to SeatAttribute value
     * @throws \InvalidArgumentException
     * @param \StructType\SeatAttribute $item
     * @return \ArrayType\ArrayOfSeatAttribute
     */
    public function addToSeatAttribute(\StructType\SeatAttribute $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SeatAttribute) {
            throw new \InvalidArgumentException(sprintf('The SeatAttribute property can only contain items of type \StructType\SeatAttribute, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SeatAttribute[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SeatAttribute|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SeatAttribute|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SeatAttribute|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SeatAttribute|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SeatAttribute|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeatAttribute
     */
    public function getAttributeName()
    {
        return 'SeatAttribute';
    }
}
