<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'RetrieveFareBasisList' => '\\StructType\\RetrieveFareBasisList',
            'RetrieveFareBasisListResponse' => '\\StructType\\RetrieveFareBasisListResponse',
            'OverrideReservationCharges' => '\\StructType\\OverrideReservationCharges',
            'OverrideReservationChargesResponse' => '\\StructType\\OverrideReservationChargesResponse',
            'ArrayOfChargeOverrideDetail' => '\\ArrayType\\ArrayOfChargeOverrideDetail',
            'ChargeOverrideDetail' => '\\StructType\\ChargeOverrideDetail',
            'TransactionInfo' => '\\StructType\\TransactionInfo',
            'ArrayOfCarrierCode' => '\\ArrayType\\ArrayOfCarrierCode',
            'CarrierCode' => '\\StructType\\CarrierCode',
            'ViewFareBasis' => '\\StructType\\ViewFareBasis',
            'ArrayOfFareBasisList' => '\\ArrayType\\ArrayOfFareBasisList',
            'FareBasisList' => '\\StructType\\FareBasisList',
            'ArrayOfHoldRule' => '\\ArrayType\\ArrayOfHoldRule',
            'HoldRule' => '\\StructType\\HoldRule',
            'ArrayOfstring' => '\\ArrayType\\ArrayOfstring',
            'ExceptionInformation.Exceptions' => '\\StructType\\ExceptionInformation_Exceptions',
            'ExceptionInformation.Exception' => '\\StructType\\ExceptionInformation_Exception',
            'ViewPNR' => '\\StructType\\ViewPNR',
            'ArrayOfAirline' => '\\ArrayType\\ArrayOfAirline',
            'Airline' => '\\StructType\\Airline',
            'ArrayOfLogicalFlight' => '\\ArrayType\\ArrayOfLogicalFlight',
            'LogicalFlight' => '\\StructType\\LogicalFlight',
            'ArrayOfPhysicalFlight' => '\\ArrayType\\ArrayOfPhysicalFlight',
            'PhysicalFlight' => '\\StructType\\PhysicalFlight',
            'ArrayOfCustomer' => '\\ArrayType\\ArrayOfCustomer',
            'Customer' => '\\StructType\\Customer',
            'ArrayOfAirlinePerson' => '\\ArrayType\\ArrayOfAirlinePerson',
            'AirlinePerson' => '\\StructType\\AirlinePerson',
            'Person' => '\\StructType\\Person',
            'ArrayOfSeatAssignment' => '\\ArrayType\\ArrayOfSeatAssignment',
            'SeatAssignment' => '\\StructType\\SeatAssignment',
            'ArrayOfSeatAttribute' => '\\ArrayType\\ArrayOfSeatAttribute',
            'SeatAttribute' => '\\StructType\\SeatAttribute',
            'ArrayOfCharge' => '\\ArrayType\\ArrayOfCharge',
            'Charge' => '\\StructType\\Charge',
            'ArrayOfReservationPaymentMap' => '\\ArrayType\\ArrayOfReservationPaymentMap',
            'ReservationPaymentMap' => '\\StructType\\ReservationPaymentMap',
            'ArrayOfBaggage' => '\\ArrayType\\ArrayOfBaggage',
            'Baggage' => '\\StructType\\Baggage',
            'ArrayOfOAFlight' => '\\ArrayType\\ArrayOfOAFlight',
            'OAFlight' => '\\StructType\\OAFlight',
            'ArrayOfOAFlightPerson' => '\\ArrayType\\ArrayOfOAFlightPerson',
            'OAFlightPerson' => '\\StructType\\OAFlightPerson',
            'ArrayOfPayment' => '\\ArrayType\\ArrayOfPayment',
            'Payment' => '\\StructType\\Payment',
            'ArrayOfHistory' => '\\ArrayType\\ArrayOfHistory',
            'History' => '\\StructType\\History',
            'ArrayOfComment' => '\\ArrayType\\ArrayOfComment',
            'Comment' => '\\StructType\\Comment',
            'ArrayOfGDSHistory' => '\\ArrayType\\ArrayOfGDSHistory',
            'GDSHistory' => '\\StructType\\GDSHistory',
            'ArrayOfReservationContact' => '\\ArrayType\\ArrayOfReservationContact',
            'ReservationContact' => '\\StructType\\ReservationContact',
            'ArrayOfContactInfo' => '\\ArrayType\\ArrayOfContactInfo',
            'ContactInfo' => '\\StructType\\ContactInfo',
            'ArrayOfVoucher' => '\\ArrayType\\ArrayOfVoucher',
            'Voucher' => '\\StructType\\Voucher',
            'ArrayOfCar' => '\\ArrayType\\ArrayOfCar',
            'Car' => '\\StructType\\Car',
            'ArrayOfHotel' => '\\ArrayType\\ArrayOfHotel',
            'Hotel' => '\\StructType\\Hotel',
            'ArrayOfPackage' => '\\ArrayType\\ArrayOfPackage',
            'Package' => '\\StructType\\Package',
            'ArrayOfPaymentMetaData' => '\\ArrayType\\ArrayOfPaymentMetaData',
            'PaymentMetaData' => '\\StructType\\PaymentMetaData',
        );
    }
}
