<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Customer StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Customer
 * @subpackage Structs
 */
class Customer extends AbstractStructBase
{
    /**
     * The Key
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Key;
    /**
     * The AirlinePersons
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfAirlinePerson
     */
    public $AirlinePersons;
    /**
     * Constructor method for Customer
     * @uses Customer::setKey()
     * @uses Customer::setAirlinePersons()
     * @param string $key
     * @param \ArrayType\ArrayOfAirlinePerson $airlinePersons
     */
    public function __construct($key = null, \ArrayType\ArrayOfAirlinePerson $airlinePersons = null)
    {
        $this
            ->setKey($key)
            ->setAirlinePersons($airlinePersons);
    }
    /**
     * Get Key value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getKey()
    {
        return isset($this->Key) ? $this->Key : null;
    }
    /**
     * Set Key value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $key
     * @return \StructType\Customer
     */
    public function setKey($key = null)
    {
        // validation for constraint: string
        if (!is_null($key) && !is_string($key)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($key, true), gettype($key)), __LINE__);
        }
        if (is_null($key) || (is_array($key) && empty($key))) {
            unset($this->Key);
        } else {
            $this->Key = $key;
        }
        return $this;
    }
    /**
     * Get AirlinePersons value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfAirlinePerson|null
     */
    public function getAirlinePersons()
    {
        return isset($this->AirlinePersons) ? $this->AirlinePersons : null;
    }
    /**
     * Set AirlinePersons value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfAirlinePerson $airlinePersons
     * @return \StructType\Customer
     */
    public function setAirlinePersons(\ArrayType\ArrayOfAirlinePerson $airlinePersons = null)
    {
        if (is_null($airlinePersons) || (is_array($airlinePersons) && empty($airlinePersons))) {
            unset($this->AirlinePersons);
        } else {
            $this->AirlinePersons = $airlinePersons;
        }
        return $this;
    }
}
