<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HoldRule StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:HoldRule
 * @subpackage Structs
 */
class HoldRule extends AbstractStructBase
{
    /**
     * The HoldDuration
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $HoldDuration;
    /**
     * The HoldLimit
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $HoldLimit;
    /**
     * The HoldRuleId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $HoldRuleId;
    /**
     * The HoursBeforeDepatureFrom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $HoursBeforeDepatureFrom;
    /**
     * The HoursBeforeDepatureTo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $HoursBeforeDepatureTo;
    /**
     * Constructor method for HoldRule
     * @uses HoldRule::setHoldDuration()
     * @uses HoldRule::setHoldLimit()
     * @uses HoldRule::setHoldRuleId()
     * @uses HoldRule::setHoursBeforeDepatureFrom()
     * @uses HoldRule::setHoursBeforeDepatureTo()
     * @param int $holdDuration
     * @param int $holdLimit
     * @param int $holdRuleId
     * @param int $hoursBeforeDepatureFrom
     * @param int $hoursBeforeDepatureTo
     */
    public function __construct($holdDuration = null, $holdLimit = null, $holdRuleId = null, $hoursBeforeDepatureFrom = null, $hoursBeforeDepatureTo = null)
    {
        $this
            ->setHoldDuration($holdDuration)
            ->setHoldLimit($holdLimit)
            ->setHoldRuleId($holdRuleId)
            ->setHoursBeforeDepatureFrom($hoursBeforeDepatureFrom)
            ->setHoursBeforeDepatureTo($hoursBeforeDepatureTo);
    }
    /**
     * Get HoldDuration value
     * @return int|null
     */
    public function getHoldDuration()
    {
        return $this->HoldDuration;
    }
    /**
     * Set HoldDuration value
     * @param int $holdDuration
     * @return \StructType\HoldRule
     */
    public function setHoldDuration($holdDuration = null)
    {
        // validation for constraint: int
        if (!is_null($holdDuration) && !(is_int($holdDuration) || ctype_digit($holdDuration))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($holdDuration, true), gettype($holdDuration)), __LINE__);
        }
        $this->HoldDuration = $holdDuration;
        return $this;
    }
    /**
     * Get HoldLimit value
     * @return int|null
     */
    public function getHoldLimit()
    {
        return $this->HoldLimit;
    }
    /**
     * Set HoldLimit value
     * @param int $holdLimit
     * @return \StructType\HoldRule
     */
    public function setHoldLimit($holdLimit = null)
    {
        // validation for constraint: int
        if (!is_null($holdLimit) && !(is_int($holdLimit) || ctype_digit($holdLimit))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($holdLimit, true), gettype($holdLimit)), __LINE__);
        }
        $this->HoldLimit = $holdLimit;
        return $this;
    }
    /**
     * Get HoldRuleId value
     * @return int|null
     */
    public function getHoldRuleId()
    {
        return $this->HoldRuleId;
    }
    /**
     * Set HoldRuleId value
     * @param int $holdRuleId
     * @return \StructType\HoldRule
     */
    public function setHoldRuleId($holdRuleId = null)
    {
        // validation for constraint: int
        if (!is_null($holdRuleId) && !(is_int($holdRuleId) || ctype_digit($holdRuleId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($holdRuleId, true), gettype($holdRuleId)), __LINE__);
        }
        $this->HoldRuleId = $holdRuleId;
        return $this;
    }
    /**
     * Get HoursBeforeDepatureFrom value
     * @return int|null
     */
    public function getHoursBeforeDepatureFrom()
    {
        return $this->HoursBeforeDepatureFrom;
    }
    /**
     * Set HoursBeforeDepatureFrom value
     * @param int $hoursBeforeDepatureFrom
     * @return \StructType\HoldRule
     */
    public function setHoursBeforeDepatureFrom($hoursBeforeDepatureFrom = null)
    {
        // validation for constraint: int
        if (!is_null($hoursBeforeDepatureFrom) && !(is_int($hoursBeforeDepatureFrom) || ctype_digit($hoursBeforeDepatureFrom))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($hoursBeforeDepatureFrom, true), gettype($hoursBeforeDepatureFrom)), __LINE__);
        }
        $this->HoursBeforeDepatureFrom = $hoursBeforeDepatureFrom;
        return $this;
    }
    /**
     * Get HoursBeforeDepatureTo value
     * @return int|null
     */
    public function getHoursBeforeDepatureTo()
    {
        return $this->HoursBeforeDepatureTo;
    }
    /**
     * Set HoursBeforeDepatureTo value
     * @param int $hoursBeforeDepatureTo
     * @return \StructType\HoldRule
     */
    public function setHoursBeforeDepatureTo($hoursBeforeDepatureTo = null)
    {
        // validation for constraint: int
        if (!is_null($hoursBeforeDepatureTo) && !(is_int($hoursBeforeDepatureTo) || ctype_digit($hoursBeforeDepatureTo))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($hoursBeforeDepatureTo, true), gettype($hoursBeforeDepatureTo)), __LINE__);
        }
        $this->HoursBeforeDepatureTo = $hoursBeforeDepatureTo;
        return $this;
    }
}
