<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SeatAttribute StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SeatAttribute
 * @subpackage Structs
 */
class SeatAttribute extends AbstractStructBase
{
    /**
     * The AttributeCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AttributeCode;
    /**
     * Constructor method for SeatAttribute
     * @uses SeatAttribute::setAttributeCode()
     * @param string $attributeCode
     */
    public function __construct($attributeCode = null)
    {
        $this
            ->setAttributeCode($attributeCode);
    }
    /**
     * Get AttributeCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAttributeCode()
    {
        return isset($this->AttributeCode) ? $this->AttributeCode : null;
    }
    /**
     * Set AttributeCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $attributeCode
     * @return \StructType\SeatAttribute
     */
    public function setAttributeCode($attributeCode = null)
    {
        // validation for constraint: string
        if (!is_null($attributeCode) && !is_string($attributeCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($attributeCode, true), gettype($attributeCode)), __LINE__);
        }
        if (is_null($attributeCode) || (is_array($attributeCode) && empty($attributeCode))) {
            unset($this->AttributeCode);
        } else {
            $this->AttributeCode = $attributeCode;
        }
        return $this;
    }
}
